package cache

import "go_dreamfactory/pb"

type (
	ISys interface {
		UpdateUser(data *pb.Cache_UserData) (err error)
	}
)

const ()

var Defsys ISys

func OnInit(config map[string]interface{}, option ...Option) (err error) {
	var options Options
	if options, err = newOptions(config, option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}

func NewSys(option ...Option) (sys ISys, err error) {
	var options Options
	if options, err = newOptionsByOption(option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}


