package cache

import (
	"errors"

	"github.com/liwei1dao/lego/utils/mapstructure"
)

type Option func(*Options)
type Options struct {
	Redis_Addr     []string
	Redis_Password string
}

func newOptions(config map[string]interface{}, opts ...Option) (Options, error) {
	options := Options{}
	if config != nil {
		mapstructure.Decode(config, &options)
	}
	for _, o := range opts {
		o(&options)
	}
	if options.Redis_Addr == nil || len(options.Redis_Addr) == 0 {
		return options, errors.New("Redis_Addr is null")
	}
	return options, nil
}

func newOptionsByOption(opts ...Option) (Options, error) {
	options := Options{}
	for _, o := range opts {
		o(&options)
	}
	if options.Redis_Addr == nil || len(options.Redis_Addr) == 0 {
		return options, errors.New("Redis_Addr is null")
	}
	return options, nil
}
