package db

import "go_dreamfactory/pb"

type (
	ISys interface {
		FindUserByAccount(account string) (*pb.DB_UserData, error)
		FindUserById(id uint32) (*pb.DB_UserData, error)
		CreateUser(user *pb.DB_UserData) error
		UpdateUser(data *pb.DB_UserData) (err error)
	}
)

var Defsys ISys

func OnInit(config map[string]interface{}, option ...Option) (err error) {
	var options Options
	if options, err = newOptions(config, option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}

func NewSys(option ...Option) (sys ISys, err error) {
	var options Options
	if options, err = newOptionsByOption(option...); err != nil {
		return
	}
	Defsys, err = newSys(options)
	return
}
